=== debian/changelog ===
vc (1.4.2-2) unstable; urgency=medium

  * Upload to unstable

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 13 Oct 2021 14:08:56 +0200

vc (1.4.2-1) experimental; urgency=medium

  * New upstream version 1.4.2

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 24 Jun 2021 17:34:35 +0200

vc (1.4.1-1) experimental; urgency=medium

  [ Simon Quigley ]
  * New upstream release.
  * Fix the watch file to correctly download new releases.
  * Remove unneeded i386 patch.

  [ Stephan Lachnit ]
  * Bump Standards-version to 4.5.1, no changes needed.
  * Update debhelper-compat to 13, no changes needed.
  * Update maintainer.

 -- Stephan Lachnit <stephanlachnit@debian.org>  Sat, 15 May 2021 14:22:30 +0200
