=== debian/control ===
Source: vc
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephan Lachnit <stephanlachnit@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Rules-Requires-Root: no
Standards-Version: 4.6.0.1
Homepage: https://github.com/VcDevel/Vc
Vcs-Browser: https://salsa.debian.org/science-team/vc
Vcs-Git: https://salsa.debian.org/science-team/vc.git

Package: vc-dev
Section: libdevel
Architecture: any-amd64 any-arm any-arm64 any-i386
Depends:
 ${misc:Depends},
Description: C++ types for explicitly data-parallel programming
 Vc is a free software library to ease explicit vectorization of C++
 code. It has an intuitive API and provides portability between
 different compilers and compiler versions as well as portability
 between different vector instruction sets. Thus an application
 written with Vc can be compiled for:
  - AVX and AVX2
  - SSE2 up to SSE4.2 or SSE4a
  - Scalar
  - AVX-512 (in development)
  - NEON (in development)
  - NVIDIA GPUs / CUDA (in development)
