=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/Vc-?(\d\S+)\.tar\.gz/vc_$1\.orig\.tar\.gz/ \
    https://github.com/VcDevel/Vc/releases .*/Vc-?(\d\S+)\.tar\.gz
