## vc 1.4.3

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -68,10 +68,10 @@
    endforeach()
 endmacro()
 
-vc_set_first_flag_of(_sse2_flag "-xSSE2" "-msse2" "/arch:SSE2")
-vc_set_first_flag_of(_sse4_1_flag "-xSSE4.1" "-msse4.1" "/arch:SSE2")
-vc_set_first_flag_of(_avx_flag "-xAVX" "-mavx" "/arch:AVX")
-vc_set_first_flag_of(_avx2_flag "-xCORE-AVX2" "-mavx2" "/arch:AVX2")
+vc_set_first_flag_of(_sse2_flag "-msse2")
+vc_set_first_flag_of(_sse4_1_flag "-msse4.1")
+vc_set_first_flag_of(_avx_flag "-mavx" "/arch:AVX")
+vc_set_first_flag_of(_avx2_flag "-march=core-avx2" "-mavx2 -mfma -mbmi2" "/arch:AVX2")
 macro(vc_add_run_target _target)
    if("${CMAKE_GENERATOR}" MATCHES "Visual Studio")
       # do nothing. This just clutters the solution explorer
@@ -133,7 +133,7 @@
    set(_target "${name}_scalar")
    list(FIND disabled_targets ${_target} _disabled)
    if(_disabled EQUAL -1 AND "${_targets}" MATCHES "Scalar")
-      file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/scalar/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/scalar/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
+      file(GLOB _extra_deps "${PROJECT_SOURCE_DIR}/Vc/scalar/*.tcc" "${PROJECT_SOURCE_DIR}/Vc/scalar/*.h" "${PROJECT_SOURCE_DIR}/Vc/common/*.h")
       add_file_dependencies(${_name}.cpp "${_extra_deps}")
       add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
       vc_set_test_target_properties(${_target} Scalar "${Vc_SCALAR_FLAGS}")
@@ -143,7 +143,7 @@
       set(_target "${name}_sse")
       list(FIND disabled_targets ${_target} _disabled)
       if(_disabled EQUAL -1)
-         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/sse/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/sse/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
+         file(GLOB _extra_deps "${PROJECT_SOURCE_DIR}/Vc/sse/*.tcc" "${PROJECT_SOURCE_DIR}/Vc/sse/*.h" "${PROJECT_SOURCE_DIR}/Vc/common/*.h")
          add_file_dependencies(${_name}.cpp "${_extra_deps}")
          add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
          vc_set_test_target_properties(${_target} SSE "${Vc_SSE_FLAGS}")
@@ -154,7 +154,7 @@
       set(_target "${name}_avx")
       list(FIND disabled_targets ${_target} _disabled)
       if(_disabled EQUAL -1)
-         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/avx/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/avx/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
+         file(GLOB _extra_deps "${PROJECT_SOURCE_DIR}/Vc/avx/*.tcc" "${PROJECT_SOURCE_DIR}/Vc/avx/*.h" "${PROJECT_SOURCE_DIR}/Vc/common/*.h")
          add_file_dependencies(${_name}.cpp "${_extra_deps}")
          add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
          vc_set_test_target_properties(${_target} AVX "${Vc_AVX_FLAGS}")
@@ -165,7 +165,7 @@
       set(_target "${name}_avx2")
       list(FIND disabled_targets ${_target} _disabled)
       if(_disabled EQUAL -1)
-         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/Vc/avx/*.tcc" "${CMAKE_SOURCE_DIR}/Vc/avx/*.h" "${CMAKE_SOURCE_DIR}/Vc/common/*.h")
+         file(GLOB _extra_deps "${PROJECT_SOURCE_DIR}/Vc/avx/*.tcc" "${PROJECT_SOURCE_DIR}/Vc/avx/*.h" "${PROJECT_SOURCE_DIR}/Vc/common/*.h")
          add_file_dependencies(${_name}.cpp "${_extra_deps}")
          add_executable(${_target} EXCLUDE_FROM_ALL ${_name}.cpp)
          vc_set_test_target_properties(${_target} AVX2 "${Vc_AVX2_FLAGS}")
@@ -264,7 +264,7 @@
          COMMAND ${CMAKE_CXX_COMPILER}
          ${incdirs} ${_flags} -O1 -DVc_IMPL=${_impl} ${ARGN} -S -o ${asmfile}
          ${CMAKE_CURRENT_SOURCE_DIR}/abi.cpp
-         DEPENDS abi.cpp ${CMAKE_SOURCE_DIR}/Vc/*/*.h ${CMAKE_SOURCE_DIR}/Vc/*/*.tcc
+         DEPENDS abi.cpp ${PROJECT_SOURCE_DIR}/Vc/*/*.h ${PROJECT_SOURCE_DIR}/Vc/*/*.tcc
          WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
          COMMENT "Build ABI test: ${asmfile}"
          VERBATIM
