=== examples/finitediff/CMakeLists.txt ===
build_example(finitediff main.cpp DISABLE Scalar)
