=== examples/scaling/CMakeLists.txt ===
build_example(scaling main.cpp)
