=== examples/simdize/CMakeLists.txt ===
build_example(simdize main.cpp)
