=== debian/changelog ===
vc (1.4.3-1) unstable; urgency=medium

  * New upstream version 1.4.3

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 27 May 2022 10:11:53 +0200

vc (1.4.2-3) unstable; urgency=medium

  * Add x86-64 feature levels

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 06 Apr 2022 16:16:21 +0200
