=== debian/control ===
--- 
+++ 
@@ -26,6 +26,3 @@
   - AVX and AVX2
   - SSE2 up to SSE4.2 or SSE4a
   - Scalar
-  - AVX-512 (in development)
-  - NEON (in development)
-  - NVIDIA GPUs / CUDA (in development)
