=== debian/watch ===
version=4
https://github.com/VcDevel/Vc/releases (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
