## vc 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 cmake_policy(SET CMP0028 NEW) # Double colon in target name means ALIAS or IMPORTED target.
 cmake_policy(SET CMP0048 NEW) # The ``project()`` command manages VERSION variables.
 
-if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
+if(PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
    message(FATAL_ERROR "You don't want to configure in the source directory!")
 endif()
 
@@ -18,7 +18,7 @@
 string(REGEX MATCH "([0-9]+)\\.([0-9]+)\\.([0-9]+)" _version_matches "${_version_lines}")
 
 project(Vc VERSION "${CMAKE_MATCH_1}.${CMAKE_MATCH_2}.${CMAKE_MATCH_3}" LANGUAGES C CXX)
-set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
 
 set(disabled_targets)
 
@@ -46,9 +46,7 @@
    endif()
 endif()
 
-# TODO: check that 'decltype' compiles
-# TODO: check that 'constexpr' compiles
-if(NOT Vc_COMPILER_IS_MSVC) # MSVC doesn't provide a switch to turn C++11 on/off AFAIK
+if(NOT Vc_COMPILER_IS_MSVC)
    AddCompilerFlag("-std=c++14" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
    if(NOT _ok)
       AddCompilerFlag("-std=c++1y" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
@@ -62,8 +60,16 @@
          endif()
       endif()
    endif()
-elseif(Vc_MSVC_VERSION LESS 180021114)
-   message(FATAL_ERROR "Vc 1.x requires C++11 support. This requires at least Visual Studio 2013 with the Nov 2013 CTP.")
+elseif(MSVC_VERSION LESS 1920)
+   message(FATAL_ERROR "Vc 1.x requires at least Visual Studio 2019.")
+   AddCompilerFlag("/std:c++14" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
+endif()
+
+if(MSVC AND (NOT DEFINED Vc_USE_MSVC_SSA_OPTIMIZER_DESPITE_BUGGY_EXP OR NOT Vc_USE_MSVC_SSA_OPTIMIZER_DESPITE_BUGGY_EXP))
+   # bug report: https://developercommunity.visualstudio.com/t/AVX-codegen-bug-on-Vc-with-MSVC-2019/1470844#T-N1521672
+   message(STATUS "WARNING! MSVC starting with 19.20 uses a new optimizer that has a bug causing Vc::exp() to return slighly wrong results.\
+ You can set Vc_USE_MSVC_SSA_OPTIMIZER_DESPITE_BUGGY_EXP=ON to still use the new optimizer on the affected MSVC versions.")
+   AddCompilerFlag("/d2SSAOptimizer-" CXX_RESULT _ok CXX_FLAGS CMAKE_CXX_FLAGS)
 endif()
 
 if(Vc_COMPILER_IS_GCC)
@@ -74,14 +80,6 @@
          )
    endif()
 elseif(Vc_COMPILER_IS_MSVC)
-   if(MSVC_VERSION LESS 1700)
-      # MSVC before 2012 has a broken std::vector::resize implementation. STL + Vc code will probably not compile.
-      # UserWarning in VcMacros.cmake
-      list(APPEND disabled_targets
-         stlcontainer_sse
-         stlcontainer_avx
-         )
-   endif()
    # Disable warning "C++ exception specification ignored except to indicate a function is not __declspec(nothrow)"
    # MSVC emits the warning for the _UnitTest_Compare desctructor which needs the throw declaration so that it doesn't std::terminate
    AddCompilerFlag("/wd4290")
@@ -120,7 +118,13 @@
 set(_srcs src/const.cpp)
 if(Vc_X86)
    list(APPEND _srcs src/cpuid.cpp src/support_x86.cpp)
-   vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX SSE+XOP+FMA4 AVX+XOP+FMA4 AVX+XOP+FMA AVX+FMA AVX2+FMA+BMI2)
+   vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX AVX+FMA AVX2+FMA+BMI2)
+   if(NOT Vc_XOP_INTRINSICS_BROKEN)
+     vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY AVX+XOP+FMA)
+     if(NOT Vc_FMA4_INTRINSICS_BROKEN)
+       vc_compile_for_all_implementations(_srcs src/trigonometric.cpp ONLY SSE+XOP+FMA4 AVX+XOP+FMA4)
+     endif()
+   endif()
    vc_compile_for_all_implementations(_srcs src/sse_sorthelper.cpp ONLY SSE2 SSE4_1 AVX AVX2+FMA+BMI2)
    vc_compile_for_all_implementations(_srcs src/avx_sorthelper.cpp ONLY AVX AVX2+FMA+BMI2)
 elseif(Vc_ARM)
@@ -183,66 +187,69 @@
    $<INSTALL_INTERFACE:include>
    )
 
-install(TARGETS Vc EXPORT VcTargets DESTINATION lib${LIB_SUFFIX})
-install(DIRECTORY Vc/ DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")
-install(FILES
-   Vc/Allocator
-   Vc/IO
-   Vc/Memory
-   Vc/SimdArray
-   Vc/Utils
-   Vc/Vc
-   Vc/algorithm
-   Vc/array
-   Vc/iterators
-   Vc/limits
-   Vc/simdize
-   Vc/span
-   Vc/type_traits
-   Vc/vector
-   DESTINATION include/Vc)
-
-# Generate and install CMake package and modules
-include(CMakePackageConfigHelpers)
-set(PACKAGE_INSTALL_DESTINATION
-   lib${LIB_SUFFIX}/cmake/${PROJECT_NAME}
-   )
-install(EXPORT ${PROJECT_NAME}Targets
-   NAMESPACE ${PROJECT_NAME}::
-   DESTINATION ${PACKAGE_INSTALL_DESTINATION}
-   EXPORT_LINK_INTERFACE_LIBRARIES
-   )
-write_basic_package_version_file(
-   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
-   VERSION ${PROJECT_VERSION}
-   COMPATIBILITY AnyNewerVersion
-   )
-configure_package_config_file(
-   ${CMAKE_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in
-   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
-   INSTALL_DESTINATION ${PACKAGE_INSTALL_DESTINATION}
-   PATH_VARS CMAKE_INSTALL_PREFIX
-   )
-install(FILES
-   cmake/UserWarning.cmake
-   cmake/VcMacros.cmake
-   cmake/AddCompilerFlag.cmake
-   cmake/CheckCCompilerFlag.cmake
-   cmake/CheckCXXCompilerFlag.cmake
-   cmake/OptimizeForArchitecture.cmake
-   cmake/FindVc.cmake
-   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
-   ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
-   DESTINATION ${PACKAGE_INSTALL_DESTINATION}
-   )
+option(Vc_ENABLE_INSTALL "Whether to install the library." ON)
+if (Vc_ENABLE_INSTALL)
+   install(TARGETS Vc EXPORT VcTargets DESTINATION lib${LIB_SUFFIX})
+   install(DIRECTORY Vc/ DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")
+   install(FILES
+      Vc/Allocator
+      Vc/IO
+      Vc/Memory
+      Vc/SimdArray
+      Vc/Utils
+      Vc/Vc
+      Vc/algorithm
+      Vc/array
+      Vc/iterators
+      Vc/limits
+      Vc/simdize
+      Vc/span
+      Vc/type_traits
+      Vc/vector
+      DESTINATION include/Vc)
+
+   # Generate and install CMake package and modules
+   include(CMakePackageConfigHelpers)
+   set(PACKAGE_INSTALL_DESTINATION
+      lib${LIB_SUFFIX}/cmake/${PROJECT_NAME}
+      )
+   install(EXPORT ${PROJECT_NAME}Targets
+      NAMESPACE ${PROJECT_NAME}::
+      DESTINATION ${PACKAGE_INSTALL_DESTINATION}
+      EXPORT_LINK_INTERFACE_LIBRARIES
+      )
+   write_basic_package_version_file(
+      ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
+      VERSION ${PROJECT_VERSION}
+      COMPATIBILITY AnyNewerVersion
+      )
+   configure_package_config_file(
+      ${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in
+      ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
+      INSTALL_DESTINATION ${PACKAGE_INSTALL_DESTINATION}
+      PATH_VARS CMAKE_INSTALL_PREFIX
+      )
+   install(FILES
+      cmake/UserWarning.cmake
+      cmake/VcMacros.cmake
+      cmake/AddCompilerFlag.cmake
+      cmake/CheckCCompilerFlag.cmake
+      cmake/CheckCXXCompilerFlag.cmake
+      cmake/OptimizeForArchitecture.cmake
+      cmake/FindVc.cmake
+      ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
+      ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
+      DESTINATION ${PACKAGE_INSTALL_DESTINATION}
+      )
+endif()
 
 option(BUILD_TESTING "Build the testing tree." OFF)
 include (CTest)
-configure_file(${CMAKE_SOURCE_DIR}/CTestCustom.cmake ${CMAKE_BINARY_DIR}/CTestCustom.cmake COPYONLY)
+configure_file(${PROJECT_SOURCE_DIR}/CTestCustom.cmake ${PROJECT_BINARY_DIR}/CTestCustom.cmake COPYONLY)
 if(BUILD_TESTING)
    add_custom_target(build_tests ALL VERBATIM)
    add_subdirectory(tests)
-endif(BUILD_TESTING)
+endif()
 
 set(BUILD_EXAMPLES FALSE CACHE BOOL "Build examples.")
 if(BUILD_EXAMPLES)
@@ -255,14 +262,14 @@
 find_program(BIN_CAT cat)
 mark_as_advanced(BIN_CAT)
 if(BIN_CAT)
-   file(REMOVE ${CMAKE_BINARY_DIR}/help.txt)
-   add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/help.txt
-      COMMAND ${CMAKE_MAKE_PROGRAM} help > ${CMAKE_BINARY_DIR}/help.txt
+   file(REMOVE ${PROJECT_BINARY_DIR}/help.txt)
+   add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/help.txt
+      COMMAND ${CMAKE_MAKE_PROGRAM} help > ${PROJECT_BINARY_DIR}/help.txt
       VERBATIM
       )
    add_custom_target(cached_help
-      ${BIN_CAT} ${CMAKE_BINARY_DIR}/help.txt
-      DEPENDS ${CMAKE_BINARY_DIR}/help.txt
+      ${BIN_CAT} ${PROJECT_BINARY_DIR}/help.txt
+      DEPENDS ${PROJECT_BINARY_DIR}/help.txt
       VERBATIM
       )
 endif()
