=== examples/linear_find/CMakeLists.txt ===
build_example(linear_find main.cpp)
