=== debian/changelog ===
vc (1.4.4-1) unstable; urgency=medium

  * New upstream version 1.4.4

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 26 Oct 2023 18:43:05 +0200

vc (1.4.3-2) unstable; urgency=medium

  * Update standards version to 4.6.1, no changes needed
  * Fix watch file due to GitHub changes

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 09 Nov 2022 22:14:18 +0100
