=== debian/watch ===
version=4
opts="searchmode=plain,filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
https://api.github.com/repos/VcDevel/Vc/releases?per_page=100 \
https://api.github.com/repos/VcDevel/Vc/tarball/v?@ANY_VERSION@
