## vc 1.4.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
-
-cmake_policy(SET CMP0028 NEW) # Double colon in target name means ALIAS or IMPORTED target.
-cmake_policy(SET CMP0048 NEW) # The ``project()`` command manages VERSION variables.
+cmake_minimum_required(VERSION 3.5)
 
 if(PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
    message(FATAL_ERROR "You don't want to configure in the source directory!")
