=== debian/changelog ===
vc (1.4.5-1) unstable; urgency=medium

  * New upstream version 1.4.5
  * Update standards version to 4.7.0, no changes needed

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 01 Aug 2024 09:04:02 +0200
