=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/VcDevel/Vc
 Vcs-Browser: https://salsa.debian.org/science-team/vc
 Vcs-Git: https://salsa.debian.org/science-team/vc.git
