=== debian/rules ===
#!/usr/bin/make -f

# Use SSE2 only on amd64
ifeq (,$(filter $(DEB_TARGET_ARCH),amd64))
	TARGET_ARCHITECTURE=none
else
	TARGET_ARCHITECTURE=x86-64
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DTARGET_ARCHITECTURE=$(TARGET_ARCHITECTURE)
